//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  PaleVioletRed
#property  indicator_width1  2

//
//
//
//
//

extern int RegressionPeriod = 10;
extern int RegressionPrice  = PRICE_MEDIAN;
extern int SmoothPeriod     = 5;

double slope[];

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   SetIndexBuffer(0,slope);
      IndicatorShortName("Linear regression slope ("+RegressionPeriod+")");
   return(0);
}

//
//
//
//
//

double  work[][2];
#define _price  0
#define _prices 1

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,RegressionPrice,i);

         double sump =0, sumw=0;
         for (int k=0; k<MathMax(SmoothPeriod,1); k++)
         {
            double weight = (RegressionPeriod-k)*(RegressionPeriod-k);
                   sump  += weight*work[r-k][_price];
                   sumw  += weight;
         }
         work[r][_prices] = MathLog(sump/sumw);
            
         //
         //
         //
         //
         //
                                    
         double sumx=0, sumxx=0, sumxy=0, sumy=0;
         for (k=0; k<RegressionPeriod; k++)
         {
            double price = work[r-k][_prices];
                   sumx  += k;
                   sumxx += k*k;
                   sumxy += k*price;
                   sumy  +=   price;
         }
         slope[i] = (RegressionPeriod*sumxy - sumx*sumy)/(sumx*sumx-RegressionPeriod*sumxx );
   }
   return(0);
}